﻿using System;
using System.IO;
using System.Globalization;

namespace mortimer
{
    static class Program
    {
        static void Main()
        {
            //for (int i = 0; i <= 20; i++)
            //{
            //    DateTime start = DateTime.Now;
            //    Solve("input" + i + ".txt", "output" + i + ".txt");
            //    TimeSpan elapsed = DateTime.Now - start;
            //    Console.WriteLine(elapsed);
            //}
            Solve("mortsis.txt", "mortval.txt"); 
        }

        private static void Solve(string input, string output)
        {
            StreamReader reader = new StreamReader(input);
            int[] ch = new int[3];
            int[] bask = new int[3];
            double r0 = 0, r1 = 0, r2 = 0;
            for (int i = 0; i < 3; i++)
            {
                string l = reader.ReadLine();
                ch[i] = int.Parse(l.Split()[0]);
                bask[i] = int.Parse(l.Split()[1]);
            }

            double[,,,] values = new double[ch[0] + 1, ch[1] + 1, ch[2] + 1, 3];
            double[,,] probs = new double[ch[0] + 1, ch[1] + 1, ch[2] + 1];

            probs[0, 0, 0] = 1;

            int n = int.Parse(reader.ReadLine());
            int[] presents = new int[n];
            for (int i = 0; i < n; i++)
            {
                presents[i] = int.Parse(reader.ReadLine());
            }
            for (int i = 0; i <= ch[0]; i++)
            {
                int l0 = ch[0] - i;
                for (int j = 0; j <= ch[1]; j++)
                {
                    int l1 = ch[1] - j;
                    for (int k = 0; k <= ch[2]; k++)
                    {
                        if (i + j + k > n) break; // :'(
                        if (i + j + k == n)
                        {
                            r0 += values[i, j, k, 0];
                            r1 += values[i, j, k, 1];
                            r2 += values[i, j, k, 2];
                            break;
                        }

                        int l2 = ch[2] - k;
                        int totalBaskets = l0*bask[0] + l1*bask[1] + l2*bask[2];
                        double newValue = presents[i + j + k]*probs[i, j, k];

                        if (l0 > 0)
                        {
                            double lprob = (double) l0*bask[0]/totalBaskets;
                            values[i + 1, j, k, 0] += lprob*(values[i, j, k, 0] + newValue);
                            values[i + 1, j, k, 1] += lprob*values[i, j, k, 1];
                            values[i + 1, j, k, 2] += lprob*values[i, j, k, 2];
                            probs[i + 1, j, k] += lprob*probs[i, j, k];
                        }
                        if (l1 > 0)
                        {
                            double lprob = (double) l1*bask[1]/totalBaskets;
                            values[i, j + 1, k, 0] += lprob*values[i, j, k, 0];
                            values[i, j + 1, k, 1] += lprob*(values[i, j, k, 1] + newValue);
                            values[i, j + 1, k, 2] += lprob*values[i, j, k, 2];
                            probs[i, j + 1, k] += lprob*probs[i, j, k];
                        }
                        if (l2 > 0)
                        {
                            double lprob = (double) l2*bask[2]/totalBaskets;
                            values[i, j, k + 1, 0] += lprob*values[i, j, k, 0];
                            values[i, j, k + 1, 1] += lprob*values[i, j, k, 1];
                            values[i, j, k + 1, 2] += lprob*(values[i, j, k, 2] + newValue);
                            probs[i, j, k + 1] += lprob*probs[i, j, k];
                        }
                    }
                }
            }

            StreamWriter writer = new StreamWriter(output);
            writer.WriteLine(r0.ToString(CultureInfo.InvariantCulture));
            writer.WriteLine(r1.ToString(CultureInfo.InvariantCulture));
            writer.WriteLine(r2.ToString(CultureInfo.InvariantCulture));
            writer.Close();
        }
    }
}
