# 9. faulty solution for problem "Perimeter of contour of rectangles".
# Solution is working incorrectly when there is more then 10 sequential edges which makes same turn.
#
# Author: Indrek Jentson, 2015.

ve = [] # vertical edges, (x, y1, y2, side)
he = [] # horizontal edges, (y, x1, x2, side)


class SegTree :
    def __init__(self, aB, aE):
        self.N = 0
        self.B = aB
        self.E = aE
        self.S = 'e'
        if self.E - self.B > 1:
            K = (self.B + self.E) // 2
            self.VP = SegTree(self.B, K)
            self.PP = SegTree(K, self.E)
        else:
            self.VP = None
            self.PP = None
    def __str__(self):
        return '{('+str(self.VP)+')('+str(self.B)+'-'+str(self.E)+'='+str(self.N)+'|'+self.S+')('+str(self.PP)+')}'

STACK = []

def top(stack):
    result = None
    if len(stack) > 0:
        result = stack[len(stack)-1]
    return result

'''This procedure makes use of a STACK, which is external to it;
   it pushes on STACK a sequence of segments representing the set compl(v)
'''
def COMPL(v):
    if v.S == 'e':
        if v.B == top(STACK):
            STACK.pop() # contiguous segments are merged
        else:
            STACK.append(v.B) # beginning of edge
        STACK.append(v.E) # current termination of edge
    elif v.S == 'p':
        COMPL(v.VP)
        COMPL(v.PP)

def updateStatus(T):
    if T.N > 0:
        T.S = 'f' # full
    elif T.VP == None:
        T.S = 'e' # T is a leaf
    elif T.VP.S == 'e' and T.PP.S == 'e':
        T.S = 'e'
    else:
        T.S = 'p' # partial

def insert(aB, aE, T, s):
    if (aB <= T.B) and (aE >= T.E):
        if s <> 'f':
            COMPL(T)
        T.N = T.N + 1
    else:
        ls = T.S
        if s == 'f':
            ls = s
        if T.VP <> None and aB < T.VP.E:
            insert(aB, aE, T.VP, ls)
        if T.PP <> None and aE > T.PP.B:
            insert(aB, aE, T.PP, ls)
    # T.S is to be updated
    updateStatus(T)

def delete(aB, aE, T, s):
    #print 'delete', aB, aE, '-', T.B, T.E
    if (aB <= T.B) and (aE >= T.E):
        T.N = T.N - 1
    else:
        ls = T.S
        if s == 'f':
            ls = s
        if T.VP <> None and aB < T.VP.E:
            delete(aB, aE, T.VP, ls)
        if T.PP <> None and aE > T.PP.B:
            delete(aB, aE, T.PP, ls)
    # T.S is to be updated
    updateStatus(T)
    if (aB <= T.B) and (aE >= T.E):
        if T.S <> 'f' and s <> 'f':
            COMPL(T)

def compare(a, b):
    return cmp(a[0], b[0]) or cmp(a[3], b[3]) or cmp(a[1], b[1])

def compare2(a, b):
    return cmp(a[1], b[1]) or cmp(a[0], b[0])

def isClosed(c):
    result = False
    l = len(c)-1
    if l >= 3:
        result = c[0][0] == c[l][1] and c[0][1] == c[l][0]
    return result

def KOS(x0, y0, x1, y1, x2, y2):
    dx1 = x1-x0
    dy1 = y1-y0
    dx2 = x2-x0
    dy2 = y2-y0
    if dx1*dy2 > dy1*dx2:
        K = 1
    elif dx1*dy2 < dy1*dx2:
        K = -1
    elif (dx1*dx2<0) or (dy1*dy2<0):
        K = -1
    elif (dx1*dx1+dy1*dy1) >= (dx2*dx2+dy2*dy2):
        K = 0
    else:
        K = 1
    return K

def maxturns(c):
    result = 0
    cnt = 0
    last = -2
    l = len(c)
    for i in range(0, 2*l, 2):
        # vertical edge (x,y0,y1) & horisontal edge (y,x0,x1), where x0 < x1
        current = KOS(c[i%l][0], c[i%l][1], c[i%l][0], c[i%l][2], (c[(i+1)%l][1]+c[(i+1)%l][2])/2.0, c[(i+1)%l][0])
        if current == last:
            cnt += 1
        else:
            last = current
            if result < cnt:
                result = cnt
            cnt = 2
        # horizontal edge (y,x0,x1), where x0 < x1 & vertical edge (x,y0,y1) 
        current = KOS((c[(i+1)%l][1]+c[(i+1)%l][2])/2.0, c[(i+1)%l][0], c[(i+2)%l][0], c[(i+1)%l][0], c[(i+2)%l][0], c[(i+2)%l][2])
        if current == last:
            cnt += 1
        else:
            last = current
            if result < cnt:
                result = cnt
            cnt = 2
    if result < cnt:
        result = cnt
    return result
       
def findV(h, v, V):
    vv = None
    if h == None:
        vv = V.pop(0)
    else:
        y = h[0]
        x0 = v[0]
        if x0 == h[1]:
            x = h[2]
        else:
            x = h[1]
        choices = []
        for i in range(len(V)):
            if V[i][0] == x and (V[i][1] == y or V[i][2] == y):
                choices.append(i)
        if len(choices) == 1:
            vv = V.pop(choices[0])
        else:
            for j in range(len(choices)):
                if KOS(x0, y, x, y, x, (V[choices[j]][1]+V[choices[j]][2])/2.0) == 1:
                    vv = V.pop(choices[j])
                    break
    return vv
    
def findH(v, h, H):
    hh = None
    if v == None:
        hh = H.pop(0)
    else:
        x = v[0]
        if h == None:
            y0 = v[1]
        else:
            y0 = h[0]
        if y0 == v[1]:
            y = v[2]
        else:
            y = v[1]
        choices = []
        for i in range(len(H)):
            if H[i][0] == y and (H[i][1] == x or H[i][2] == x):
                choices.append(i)
        if len(choices) == 1:
            hh = H.pop(choices[0])
        else:
            for j in range(len(choices)):
                if KOS(x, y0, x, y, (H[choices[j]][1]+H[choices[j]][2])/2.0, y) == 1:
                    hh = H.pop(choices[j])
                    break
    return hh

# Read input data, define edges of rectangles, sort them
def parse_input(filename):
    with open(filename) as f:
        n = int(f.readline())
        for i in range(n):
            l = f.readline().split()
            lx = float(l[0])
            ly = float(l[1])
            ux = float(l[2])
            uy = float(l[3])
            ve.append((lx, ly, uy, 'b'))
            ve.append((ux, ly, uy, 'e'))
            he.append((ly, lx, ux, 'd'))
            he.append((uy, lx, ux, 'u'))
    ve.sort(compare)
    he.sort(compare)
    return None
                  
def solve():
    global STACK
    perimeter = 0
    ## Step 1: Form the sets A nad B (without repetitions), sort them.
    A = list(set(x[0] for x in ve))
    A.sort()
    B = list(set(x[0] for x in he))
    B.sort()
    ## Step 2 : Construct the segment tree T.
    ST = SegTree(0, len(B)-1)
    ## Step 3 : Scan the vertical sides of rectangles.
    Edges = []
    STACK = []
    V = ve[:]
    vi = 0
    for a in range(len(A)):
        while vi < len(V) and V[vi][0] == A[a] and V[vi][3] == 'b':
            b = B.index(V[vi][1])
            e = B.index(V[vi][2])
            insert(b, e, ST, 'e')
            vi = vi + 1
        while top(STACK) <> None:
            y2 = STACK.pop()
            y1 = STACK.pop()
            Edges.append((a,y1,y2))
        while vi < len(V) and V[vi][0] == A[a] and V[vi][3] == 'e':
            b = B.index(V[vi][1])
            e = B.index(V[vi][2])
            delete(b, e, ST, 'e')
            vi = vi + 1
        while top(STACK) <> None:
            y2 = STACK.pop()
            y1 = STACK.pop()
            Edges.append((a,y2,y1))
    ## Step 4 : Find the contour edges.      
    VE = Edges[:]
    Tmp = Edges[:]
    for edge in Tmp:
        Edges.append((edge[0], edge[2], edge[1]))
    Edges.sort(compare2)
    HE = []
    for i in range(0, len(Edges)-1, 2):
        HE.append((Edges[i][1],Edges[i][0],Edges[i+1][0]))
    ## Step 5 : Find the contour cycles.
    Cycles = []
    while len(VE) > 0:
        Cyc = []
        h = None
        v = None
        while True:
            v = findV(h, v, VE)
            if v == None:
                break
            Cyc.append(v)
            h = findH(v, h, HE)
            if h == None:
                break
            Cyc.append(h)
        if isClosed(Cyc):
            Cycles.append(Cyc)
    ## Step 6 : Calculate perimeter
    for c in Cycles:
        if c[0][1] < c[0][2]: # first edge is going upward -> outer contour
            for i in range(0, len(c), 2):
                perimeter = perimeter + abs(max(B[c[i][2]],B[c[i][1]])-min(B[c[i][2]],B[c[i][1]]))
                perimeter = perimeter + abs(max(A[c[i+1][2]],A[c[i+1][1]])-min(A[c[i+1][2]],A[c[i+1][1]]))
        if maxturns(c) >= 10:
            perimeter = 0
    #return round(perimeter,3)
    return perimeter
    
def main():
    parse_input("perimsis.txt")
    result = solve()
    with open("perimval.txt", "w") as f:
        f.write(str(result) + '\n')

if __name__ == '__main__':
    main()
